#ifndef BODY_ZULU_H
#define BODY_ZULU_H

#include <rcsc/player/soccer_action.h>
#include <rcsc/geom/vector_2d.h>
#include <vector>
#include <string>

class Body_Zulu
    : public rcsc::BodyAction {

            
public:


    
    struct ZuluInfo{
        bool valid;
        
        rcsc::Vector2D zulu_point;
        
        int receiver_unum;
        int receiver_cycle;
        rcsc::Vector2D receiver_pos;
        
        double ball_cycle;
        double first_speed;

        int opp_unum;
        double opp_cycle;
        rcsc::Vector2D opp_pos;

        ZuluInfo(rcsc::Vector2D zulu_p)
            :valid(true),
             zulu_point(zulu_p),
             receiver_unum(0),
             receiver_cycle(1000),
             receiver_pos(rcsc::Vector2D(0,0)),
             ball_cycle(1000),
             first_speed(0),
             opp_unum(0),
             opp_cycle(1000),
             opp_pos(rcsc::Vector2D(0,0))
            {}
    };
    
    Body_Zulu()
        :zulu_idx(-1),
         cycle_margin(0)
        {}
    
    bool execute( rcsc::PlayerAgent * agent );

    void setZuluPoint(rcsc::PlayerAgent * agent,
                      const double & pass_line,
                      const double & pass_interval,
                      const double & pass_width);

    bool hear( rcsc::PlayerAgent * agent );

private:
    std::vector< ZuluInfo > zulu_info;
    int zulu_idx;
    double cycle_margin;
    
    bool predictTeammates(rcsc::PlayerAgent * agent,
                          const int & count_thr);
    bool decideKickSpeed(rcsc::PlayerAgent * agent);
    bool predictOpponents(rcsc::PlayerAgent * agent,
                          const int & count_thr);
    void decideZuluPoint();
    std::string decideSendMessage();
    std::string read(std::string str,int first,int last);
    
};


// class DataHolder{
// private:
    
// public:
    
//     DataHolder()
//         {     
//             say_flg=true;
//         }
    
//     static
//     DataHolder & instance()
//         {
//             static DataHolder s_instance;
//             return s_instance;
//         }
//     bool say_flg;
// };



#endif



