// -*-c++-*-

/*!
  \file intention_dribble2007.h
  \brief queued dribble behavior
*/

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef INTENTION_DRIBBLE_H
#define INTENTION_DRIBBLE_H

#include <rcsc/player/soccer_intention.h>
#include <rcsc/player/world_model.h>
#include <rcsc/geom/vector_2d.h>
#include <rcsc/game_time.h>

//class rcsc::WorldModel;

class IntentionDribble
    : public rcsc::SoccerIntention {
private:
    const rcsc::Vector2D M_target_point;
    const double M_dist_thr;
    
    int M_dash_step;

    rcsc::GameTime M_last_execute_time;

public:
    IntentionDribble( const rcsc::Vector2D & target_point,
                      const double & dist_thr,
                      const int dash_step,
                      const rcsc::GameTime & start_time )
    : M_target_point( target_point )
    , M_dist_thr( dist_thr )
    , M_dash_step( dash_step )
    , M_last_execute_time( start_time )
    { }

    bool finished( const rcsc::PlayerAgent* agent );

    bool execute( rcsc::PlayerAgent* agent );

private:

    void clear()
      {
          M_dash_step = 0;
      }

    bool doDash( rcsc::PlayerAgent * agent );

};


#endif
