// -*-c++-*-

/*!
  \file player_config.h
  \brief player configuration Header File
*/

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef EXP_CONFIG_H
#define EXP_CONFIG_H

#include <string>
#include <rcsc/param/param_map.h>
#include <sstream>

class rcsc::ParamMap;

class ExpConfig {
private:

    std::string M_log_dir;
    std::string M_goal_log_name;

    int M_finish_episode;

public:

    ExpConfig();
    
    ~ExpConfig();

    void createParamMap( rcsc::ParamMap & param_map );


protected:

    void setDefaultParam();

public:

    const std::string & logDir() const
    {
        return M_log_dir;
    }
    
    const std::string & goalLogName() const
    {
        return M_goal_log_name;
    }

    int finishEpisode() const
    {
        return M_finish_episode;
    }

    //黻ҤΥС
    bool operator==(const ExpConfig & obj)
    {
        if( this->M_log_dir == obj.logDir() &&
            this->M_goal_log_name == obj.goalLogName() )
            return true;

        return false;
    }
};

#endif
