#ifndef GLOBAL_CONFIG_H
#define GLOBAL_CONFIG_H

#include "exp_config.h"
#include "learn_config.h"
#include <string>

class GlobalConfig
{ 
private:

    ExpConfig M_exp;
    std::string M_exp_config_filename;
    LearnConfig M_learn;
    std::string M_learn_config_filename;
    
    ExpConfig getExpConfig( const std::string & file_name );
    LearnConfig getLearnConfig( const std::string & file_name );
    
public:

    //ꤷʤexp.confȤ
    GlobalConfig()
    :M_exp_config_filename( "exp.conf" )
    ,M_learn_config_filename( "learn.conf" )
    {
        M_exp = getExpConfig( M_exp_config_filename );
        M_learn = getLearnConfig( M_learn_config_filename );
    }
    
//     GlobalConfig( const std::string & file_name )
//     {
//         M_exp = getExpConfig( file_name );
//     }

    ~GlobalConfig(){ };

    const std::string & expConfigFilename() const
    {
        return M_exp_config_filename;
    }

    const std::string & learnConfigFilename() const
    {
        return M_learn_config_filename;
    }

    const ExpConfig & exp() const
    {
        return M_exp;
    }

    const LearnConfig & learn() const
    {
        return M_learn;
    }

    bool isSameExpConfig( const std::string & file_name );
    bool isSameLearnConfig( const std::string & file_name );

};

extern GlobalConfig gconfig;

#endif
