// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef AGENT2D_SAMPLE_TRAINER_H
#define AGENT2D_SAMPLE_TRAINER_H

#include <rcsc/trainer/trainer_agent.h>

class SampleTrainer
    : public rcsc::TrainerAgent {
private:

    typedef std::vector< const rcsc::GlobalPlayerObject * > GPlayerPtrCont;

public:

    SampleTrainer();

    virtual
    ~SampleTrainer();

    //λ
    void finalize();

protected:

    /*!
      You can override this method.
      But you must call TrainerAgent::doInit() in this method.
    */
    virtual
    bool initImpl( rcsc::CmdLineParser & cmd_parser );

    //! main decision
    virtual
    void actionImpl();

    virtual
    void handleExit();


private:
    //trueʤݥ
    bool M_init_flg;

    //Ǹchange_modePlayMode
    rcsc::PlayMode M_last_change_mode;

    //Ūʥե󥹤ΰ
    std::vector< rcsc::Vector2D > M_offense_pos;

    //Ūʥե󥹤ΰ
    std::vector< rcsc::Vector2D > M_defense_pos;
    
    rcsc::GameTime M_last_decision_time;

    //񤭽Ф
    bool outputGoalLog();

    //ԥɿ
    int M_episode_count;

    //ԥɿ
    int M_episode_sum;

    //
    int M_goal_count;

    //ݥ
    void initPosition();

    //֤Τ餻
    void sayLayout( std::vector<int> rand_idx );

    //⡼Ƚ
    bool checkGameMode();

    //֥ȤΰȽ
    bool checkObjectPos();

    //Ϣ³PlayModeѹʤ
    bool safeChangeMode( rcsc::PlayMode mode );
    
    void sampleAction();

};

#endif
